#define BONITO_HTIO_BASE_VA 0x90000efdfc000000
LEAF(i2cread)
    ori a0,a0,1
    /* set device address */
    dli  v0, BONITO_HTIO_BASE_VA + SMBUS_HOST_ADDRESS

    sb  a0, 0(v0);

    /* store register offset */
    dli  v0, BONITO_HTIO_BASE_VA + SMBUS_HOST_COMMAND
    sb  a1, 0(v0);

    /* read byte data protocol */
    li  v0, 0x08
    dli  v1, BONITO_HTIO_BASE_VA + SMBUS_HOST_CONTROL
    sb  v0, 0(v1);

    /* make sure SMB host ready to start, important!--zfx */
    dli  v1, BONITO_HTIO_BASE_VA + SMBUS_HOST_STATUS
    lbu v0, 0(v1)
    andi v0,v0, 0x1f
    beqz  v0,1f
    nop
    sb  v0, 0(v1)
    lbu v0, 0(v1)   #flush the write
1:
    /* start */
    dli  v1, BONITO_HTIO_BASE_VA + SMBUS_HOST_CONTROL
    lbu v0, 0(v1)
    ori v0, v0, 0x40
    sb  v0, 0(v1);

    /* wait */
    dli  v1, BONITO_HTIO_BASE_VA + SMBUS_HOST_STATUS
1:
    lbu  v0, 0(v1)
    andi v0, SMBUS_HOST_STATUS_BUSY
    bnez  v0, 1b  #IDEL ?
    nop

    dli  v1, BONITO_HTIO_BASE_VA + SMBUS_HOST_STATUS
    lbu v0, 0(v1)
    andi v0,v0, 0x1f
    beqz  v0,1f
    nop
    sb  v0, 0(v1)   #reset
    lbu v0, 0(v1)   #flush the write
1:
    dli  v1, BONITO_HTIO_BASE_VA + SMBUS_HOST_DATA0
    lbu  v0, 0(v1)

    jr      ra
    nop
END(i2cread)
//New S1 defination
#define SPD_NODEVICE  0xff
#define SPD_TYPEDDR2  0x8
#define SPD_TYPEDDR3  0xb
#define SPD_NODIMM	  0x0

#define	DDRTYPE_MASK  0x7
#define	DDRPERSZ_512M 0x100
#define	DDRPERSZ_1G   0x200
#define	DDRPERSZ_2G   0x400

#define	SPD_MEMTYPE_OFFSET	0x02
#define	SPD_ROWADDR_OFFSET	0x03
#define	SPD_COLADDR_OFFSET	0x04
#define	SPD_DIMRANK_OFFSET	0x11
#define	SPD_RKDESITY_OFFSET	0x1f

#define	SPD_DDR2SIZE_512M	0x80
#define	SPD_DDR2SIZE_1G		0x01
#define	SPD_DDR2SIZE_2G		0x02

#define	DDR2SIZE_512M_MASK	0x10
#define	DDR2SIZE_1G_MASK	0x20
#define	DDR2SIZE_2G_MASK	0x30
#define	DDR2SIZE_MASK	    0x70

/************************************************************
 * Input: a0, i2c device ID; a1, in MC0 or MC1 flags
 * Output: v0, equals orignal s1, included all DIMM info
************************************************************/
LEAF(PROBE_DIMM) 
	move  a2,ra;
	move  s2,a0;  //store a0: i2C DEVICE id, s2 can be only used before mszie set
	move  s3,a1;  //store a1: MC0 or MC1 used flags

	li	a1, 2;
	bal	i2cread;
	nop;
	beq	v0,SPD_TYPEDDR3, 4f;
	nop;
	beq	v0,SPD_TYPEDDR2, 4f;
	nop;

	xor	v0,v0
	jr	a2
	nop
	
4:
	/* 
	 *set DDR type @ s1[31:30] 
     *0b00 NO_DIMM 0b10 DDR2  0b11 DDR3
	 *assumed here v0 should be 0xb or 0x8 
	 *bne	v0,SPD_TYPEDDR3, ddr2 
	 */ 
	li	s1,0x0

	move  t1,v0
	subu  t1, 0x8
	beqz  t1, 400f
	nop
	dli	  v0,0xc0000000
	li   t7,0x3
	b	  500f
	nop
400:
	dli	v0, 0x80000000
    li t7,0x2
500:

	or	s1,v0;

	/* 
	 *set  CONTROLLER_SELECT@ s1[3:2] 
	 * a1 should set to be MC0_USED or MC1_USD 
	 * Firt check whether BOTH MC0 and MC1 used, if
     * true,set s1[3:2] = 2b'00
	 */
	andi  t1,s3,0xc
	or	s1,t1;

	/* 
	 * added for DDR3 check
	 * if not ddr3,jump to 100f
     */
    subu a0,t7,0x2
    beqz a0,100f
    nop

    //DDR3
    move    a0, s2;  //store a1: REG offset in i2c dev  
    li      a1, 4;
    bal     i2cread;
    nop;
    andi    v0, v0, 0xf 
    addi    v0, v0, 25 // 2**25 = 256Mb/8
    move    t2, v0

    //step 2. multi (Primary bus width)
    move    a0, s2;  //store a1: REG offset in i2c dev
    li      a1, 8;
    bal     i2cread;
    nop;
    andi    v0,0x7
    addi    v0,0x3  //2**3 = 8 bit
    daddu   t2,v0

    //step 3. divide (SDARM width)
    move    a0, s2;  //store a1: REG offset in i2c dev
    li      a1, 7;
    bal     i2cread;
    nop;
    andi    v0,0x7
    addi    v0,0x2  //2**3 = 8 bit
    dsubu   t2,v0

    //step 4. mulip * (number of Ranks)
    li      a0,0x1
    dsll    t2,a0,t2
    move    a0, s2;  //store a1: REG offset in i2c dev
    li      a1, 7;
    bal     i2cread;
    nop;
    andi    v0,0x38
    srl     v0,v0,0x3
    move    a0,t2
continue_add:
    beqz    v0, calculate_over
    nop
    daddu   t2,t2, a0
    subu    v0,1
    b       continue_add
    nop
calculate_over:
    // step 5. merge memsz t2 into s1
    dli     t3,0x20000000
    beq     t2,t3, 311f;
    nop;
    dli     t3,0x40000000
    beq     t2,t3, 312f;
    nop;
    dli     t3,0x80000000
    beq     t2,t3, 313f;
    nop;
    dli     t3,0x100000000
    beq     t2,t3, 314f;
    nop;
    dli     t3,0x200000000
    beq     t2,t3, 315f;
    nop;
311:
    li      t2, 0x100
    b    out_probesize  // 512M
    nop
312:
    li      t2, 0x200        // 1G
    b    out_probesize
    nop
313:
    li      t2, 0x400        // 2G
    b    out_probesize
    nop
314:
    li      t2, 0x800        // 4G
    b    out_probesize
    nop
315:
    li  t2, 0x1000        // 8G
    b    out_probesize
    nop

out_probesize:
    or      s1, s1, t2
    nop 
    b       15f
    nop 
100:
	/* 
	 * set SIZE_PER_CONTROLLE @ s1[14:8] 
	 * step 1: read out number of DIMMS Ranks(CS) 
	 */
	move a0, s2;  //store a1: REG offset in i2c dev	
	li	a1, 5;
	bal	i2cread;
	nop;
	andi  v0,0x3; // MASK for DIMMS Ranks(CS)
	move  t2,v0;

	//bez t2,out
	nop
	addi t2,0x1

	/* step 2: read out  DIMMS size */
	move  a0,s2;
	li	a1, 31;
	bal	i2cread;
	nop;
	bne	v0,SPD_DDR2SIZE_512M, 11f;
	nop;
	li	v0, 0x20000000
	b 1f;
	nop;
11:
	bne	v0,SPD_DDR2SIZE_1G, 12f;
	nop;
	li	v0, 0x40000000
	b 1f;
	nop;
12:
	bne	v0,SPD_DDR2SIZE_2G, 1f;
	nop;
	li	v0, 0x80000000;
1:
	/* step 3: calculate each mem SIZE of one slot*/
	beq	t2,0x1,21f;
	nop
	sll	v0,0x1
21:
	bne	v0,0x20000000, 13f
	nop;
	ori	s1,DDRPERSZ_512M ;
	b 15f;
	nop
13:
	bne	v0,0x40000000, 14f
	nop
	ori	s1,DDRPERSZ_1G;
	b 15f;
	nop
14:
    /* only support 512M,1G,2G per DIMM now */
	bne	v0,0x80000000, 15f
	nop
	ori	s1,DDRPERSZ_2G;
15:
    subu a0,t7,0x3
    beqz a0,1601f	  // jump to ddr3 CS_MAP setting
    nop
	// below is  ddr2 CS_MAP setting
	/* check whether MC0 or MC1 used to set CS_MAP */
	move  a0,s3
	andi  a0,0xc
	bne	a0,	MC0_USED, 2f;
	nop;

	/* set DDR MC0_CS_MAP @s1[19:16] */

	// First,check whether MC0DIMM0 used 
	move  a0,s3
	andi  a0,0xf0
	bne	  a0,0x30,160f
	nop

	// MC0_DIMM0
	li  t0,0x1
	sll  t0,16
	or  s1,t0
	move  a0,s2;
	li	a1, 5;
	bal	i2cread;
	nop;
	andi  v0,0x1;
	beq	v0,0x0,16f;
	nop;
	li   t0,0x1
	sll  t0,17
	or   s1,t0
	b	16f
	nop

160:
	// MC0_DIMM1
	li  t0,0x1
	sll  t0,18
	or  s1,t0
	move  a0,s2;
	li	a1, 5;
	bal	i2cread;
	nop;
	andi  v0,0x1;
	beq	v0,0x0,16f;
	nop;
	li  t0,0x1
	sll  t0,19
	or s1,t0
16:
	/* set DDR2 MC0_COL_SIZE @s1[22:20] */
	move  a0,s2;
	li	a1, 4;
	bal	i2cread;
	nop;
	li	t0,14;
	sub	t0,v0;
	sll	t0,0x14;
	or	s1,t0;

	/* set MC0_EIGHT_BANK @s1[23] */
	move  a0,s2;
	li	a1, 17;
	bal	i2cread;
	nop;
	andi  v0,0x8;
	srl	v0,0x3;
	sll	v0,0x17;  //MC0_EIGHT_BANK shift
	or	s1,v0;

	/* set DDR MC0_ROW_SIZE @s1[26:24] */
	move  a0,s2;
	li	a1, 3;
	bal	i2cread;
	nop;
	li	t0,15;
	sub	t0,v0;
	sll	t0,0x18;
	or	s1,t0;
	b	1602f
	nop
    
1601: 
	// below is  ddr3 CS_MAP setting

	/* check whether MC0 or MC1 used to set CS_MAP */
	move  a0,s3
	andi  a0,0xc
	bne	a0,	MC0_USED, 2f;
	nop;

	/* set DDR MC_CS_MAP @s1[19:16] */

	// First,check whether MC0DIMM0 used 
	move  a0,s3
	andi  a0,0xf0
	bne	  a0,0x30,170f
	nop

	// MC0_DIMM0
	li  t0,0x1
	sll  t0,16
	or	s1, t0 // at leaset one bit is selected, CS_MAP[0]
	
	move  a0,s2;
	li	a1, 7;
	bal	i2cread;
	nop;
	andi  v0,0x38;
	beq	v0,0x0,17f;
	nop;
	//ori	s1,0x200; // set CS_MAP[1] = 1'b1
	li  t0,0x1
	sll t0,17
	or  s1,t0
	b	17f
	nop
170:
	// MC0_DIMM1
	li  t0,0x1
	sll  t0,18
	or	s1, t0 // at leaset one bit is selected, CS_MAP[2]
	
	move  a0,s2;
	li	a1, 7;
	bal	i2cread;
	nop;
	andi  v0,0x38;
	beq	v0,0x0,17f;
	nop;
	li  t0,0x1
	sll  t0,19
	or	s1, t0 // at leaset one bit is selected, CS_MAP[2]
17:
	/* set DDR3 MC0_COL_SIZE @s1[22:20] */
	move  a0,s2;
	li	a1, 5;
	bal	i2cread;
	nop;
	andi  v0,0x7
	addi  v0,0x9
	li	t0,14;
	sub	t0,v0;
	sll	t0,0x14;
	or	s1,t0;

	/* set MC0_EIGHT_BANK @s1[23] */
	li   a0,0x1
	sll  a0,23
	or	s1,a0; // at leaset 8 banks

	/* set DDR MC0_ROW_SIZE @s1[26:24] */
	move  a0,s2;
	li	a1, 5;
	bal	i2cread;
	nop;
	andi  v0,0x38
	srl	  v0,0x3
	li	t0,3;
	sub	t0,v0;
	sll	t0,0x18;
	or	s1,t0;
1602:
	b out;
	nop;

2:	/* MC1_USED */
    subu a0,t7,0x3
    beqz a0,2601f	  // jump to ddr3 CS_MAP setting
    nop    

	// below begin to set DDR2 CS_MAP
	
	// First,check whether MC1DIMM0 used 
	move  a0,s3
	andi  a0,0xf0
	bne	  a0,0x30,260f
	nop

	/* set DDR MC1_CS_MAP @s1[19:16] ?  */
	//below check for MC1_DIMM0
	li  t1,0x1;
    sll t1,16;
    or s1,t1
	move  a0,s2;
	li	a1, 5;
	bal	i2cread;
	nop;
	andi  v0,0x1;
	beq	v0,0x0,26f;
	nop;
	li  t1,0x1;
    sll t1,17;
    or s1,t1
    b	26f
	nop

260: 
    // MC1_DIMM1
	li  t1,0x1;
    sll t1,18;
    or s1,t1    
	move  a0,s2;
	li	a1, 5;
	bal	i2cread;
	nop;
	andi  v0,0x1;
	beq	v0,0x0, 26f
	nop
	li  t1,0x1;
    sll t1,19;
    or s1,t1    
26:
	

	/* set DDR MC1_COL_SIZE @s1[22:20] */
	move  a0,s2;
	li	a1, 4;
	bal	i2cread;
	nop;
	li	t0,14;
	sub	t0,v0;
	sll	t0,0x14;
	or	s1,t0;

	/* set MC1_EIGHT_BANK @s1[23] ? */
	move  a0,s2
	li	a1, 17;
	bal	i2cread;
	nop;
	andi  v0,0x8;
	srl	v0,0x3;
	sll	v0,23;  //MC0_EIGHT_BANK shift
	or	s1,v0;

	/* set DDR MC1_ROW_SIZE @s1[26:24] */
	move  a0,s2;
	li	a1, 3;
	bal	i2cread;
	nop;
	li	t0,15;
	sub	t0,v0;
	sll	t0,0x18;
	or	s1,t0;
	b	2602f
	nop

2601:
	// below begin to set DDR3 CS_MAP

	// First,check whether MC1DIMM0 used 
	move  a0,s3
	andi  a0,0xf0
	bne	  a0,0x30,270f
	nop

	/* set DDR MC1_CS_MAP @s1[19:16] ?  */
	//below check for MC1_DIMM0
	li  t0,0x1
	sll t0,16
	or	s1, t0 // at leaset one bit is selected, CS_MAP[0]
	move  a0,s2;
	li	a1, 7;
	bal	i2cread;
	nop;
	andi  v0,0x38;
	beq	v0,0x0,27f;
	nop;
    li  t0,0x1
    sll t0,17
	or	s1,t0; // set CS_MAP[1] = 1'b1
	b	27f
	nop

270: 
    // MC1_DIMM1
    li  t0,0x1
    sll  t0,18
	or	s1, t0  // at leaset one bit is selected
	move  a0,s2;
	li	a1, 7;
	bal	i2cread;
	nop;
	andi  v0,0x38;
	beq	v0,0x0, 27f
	nop
	li  t0,0x1
	sll t0,19
	or	s1,t0  //set CS_MAP[3]=1'b1
27:
	
	/* set DDR3 MC1_COL_SIZE @s1[22:20] */
	move  a0,s2;
	li	a1, 5;
	bal	i2cread;
	nop;
	andi  v0,0x7
	addi  v0,0x9
	li	t0,14;
	sub	t0,v0;
	sll	t0,0x14;
	or	s1,t0;

	/* set MC1_EIGHT_BANK @s1[23] */
    li t0,0x1
    sll t0,23
    or s1,t0

	/* set DDR MC0_ROW_SIZE @s1[26:24] */
	move  a0,s2;
	li	a1, 5;
	bal	i2cread;
	nop;
	andi  v0,0x38
	srl	  v0,0x3
	li	t0,3;
	sub	t0,v0;
	sll	t0,0x18;
	or	s1,t0;
2602:

out: /* out of MC0_CS_MAP or MC1_CS_MAP */

    /* Registered DIMM or Unbuffered DIMM  S1[28]*/
    //default U DIMM
    move a0,s2
    li  a1,3
    bal i2cread
    nop 
    li  t0,0x2//U DIMM
    beq v0,t0,1f
    nop
    li  t0,0x1
    sll t0,28
    or s1,t0
    nop
    
1:  
    //DIMM_WIDTH 32bits or 64bits
    //default 64 bits
    move a0,s2
    li  a1,8
    bal i2cread
    nop
    li  t0,0x3
    beq v0,t0,2f
    nop
    li t0,0x1
    sll t0,27
    or s1,t0
    nop    
2:
	move  v0,s1
	jr	a2
	nop
END(PROBE_DIMM)

