/*
 * Copyright (c) 2007 SUNWAH HI-TECH  (www.sw-linux.com.cn)
 * Wing Sun	<chunyang.sun@sw-linux.com>
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by Opsycon AB, Sweden.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/errno.h>
#include <sys/endian.h>

#include <pmon.h>
#include <exec.h>
#include <pmon/loaders/loadfn.h>

#include <termio.h>
#include <endian.h>

#include <signal.h>
#include <setjmp.h>
#include <ctype.h>

#ifdef _KERNEL
#undef _KERNEL
#include <sys/ioctl.h>
#define _KERNEL
#else
#include <sys/ioctl.h>
#endif

#ifdef __mips__
#include <machine/cpu.h>
#endif

#define LINES_MAX 8192

int cmd_cat(int ac, char *av[])
{
    char path[256] = { 0 };
    int bootfd;
    int n = LINES_MAX;

    char *p_file_buf = NULL;
    char line_buf[512] = { 0 };
    int file_index = 0;
    int file_size;

    if (ac != 2)
	return -1;

    strcpy(path, av[1]);

    if ((bootfd = open(path, O_RDONLY | O_NONBLOCK)) < 0) {
	perror(path);
	return EXIT_FAILURE;
    }

    p_file_buf = malloc(LINES_MAX);
    if (!p_file_buf) {
	printf("Error: malloc in cmd_cat failed!\n");
	return -1;
    }
    memset(p_file_buf, 0, LINES_MAX);
    file_size = read(bootfd, p_file_buf, LINES_MAX);
    printf("\n");
    while (file_index < file_size) {
	memset(line_buf, 0, 512);
	read_line(p_file_buf, line_buf, &file_index, file_size);
	printf("%s", line_buf);
    }
    close(bootfd);

    free(p_file_buf);
    return 0;
}

/*
 *  Command table registration
 *  ==========================
 */

static const Cmd CatCmd[] = {
    {"RAYS Commands for PMON 2000"},
    {"cat", "filename to display ",
     0,
     "Display file content.",
     cmd_cat, 2, 2, 0},
    {0, 0}
};

static void init_cmd __P((void)) __attribute__ ((constructor));

static void init_cmd()
{
    cmdlist_expand(CatCmd, 1);
}
